<?php

namespace App\Console\Commands;

use App\Http\Controllers\MassegesController;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;
use Exception;
use Carbon\Carbon;
use App\Models\Subscription;
use App\Models\Transaction;
use App\Models\User;
use App\Models\Wallet;

class RemainUserSubscriptionCommand extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'RemainUserSubscriptionCommand';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return int
     */
    public function handle()
    {
        try {
            
            $subscriptions = Subscription::where('payment_remain','>',0)->get();
            foreach ($subscriptions as $subscription) {
                        try {
                        
                            $user = User::find($subscription->user_id);
                        
                            $MessageController = new MassegesController();
                            
                            try {
                                
                                // $MessageController->sendSmsMessage("عزيزي المشترك $user->name في شبكة نيو برايت نت إجمالي المبالغ المستحقة $remain لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي", $user->phone_number);
                                return 1;
                            } catch (Exception $exception) {
                            }
                            
                    } catch (Exception $e) {
                        
                        throw $e;
                    }
            }
        } catch (\Exception $e) {
        }
        return 1;
    }
}
