<?php

namespace App\Http\Controllers;

use App\Models\Admin;
use App\Models\EndPoint;
use App\Models\Subscription;
use App\Models\Transaction;
use App\Models\User;
use App\Models\Valid;
use App\Models\Wallet;
use App\Traits\ApiResponseTrait;
use Carbon\Carbon;
use Exception;
use Illuminate\Database\QueryException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Tymon\JWTAuth\Facades\JWTAuth;
use Illuminate\Support\Facades\Validator;


class AdminController extends Controller
{
    use ApiResponseTrait;

    public function test()
    {
        // try {
        //     $currentDate = Carbon::now();
        //     $subscriptions = Subscription::where('end_date', $currentDate->toDateString())->get();
        //     foreach ($subscriptions as $subscription) {
        //         if ($subscription->auto_renewal == 1) {
        //             $sub= Subscription::find($subscription->id);
        //             DB::beginTransaction();
        //             try {
        //                 $step1 = false;
        //                 $step2 = false;
        //                 $step3 = false;

        //             //1 step => udating the duration
        //                 $startDate = Carbon::parse($sub->start_date);
        //                 $difference = $currentDate->diffInDays($startDate);
        //                 $sub->start_date = $currentDate->toDateString();
        //                 $sub->end_date = $currentDate->addDays($difference)->toDateString();

        //                 $step1 = true;
        //             //2 step => pay for the old remain
        //                 $wallet = Wallet::where('user_id', $sub->user_id)->first();

        //                 $balance = ((Double)$wallet->amount); //20
        //                 $remain = ((Double)$sub->payment_remain); //100
        //                 $totalPaid = ((Double)$sub->payment_total); 
        //                 if ($remain > $balance) { //false

        //                     $totalPaid=$totalPaid+$balance;

        //                     $remain = $remain - $balance;

        //                     $balance = 0;

        //                 } else if ($balance > $remain) { //false
                            
        //                     $totalPaid=$totalPaid+$remain;

        //                     $balance = $balance - $remain;

        //                     $remain = 0;

        //                 } else if ($balance == $remain) { //true
                            
        //                     $totalPaid=$totalPaid+$remain;

        //                     $remain = 0;

        //                     $balance = 0;

        //                 }

        //                 $wallet->amount = $balance;
        //                 $sub->payment_remain = $remain;
        //                 $sub->payment_total =$totalPaid; 

        //                 $step2 = true;
        //             //3 step => add the cost of renwal subscription to the remain amount
        //                 $sub->payment_remain = ((Double)$sub->payment_remain) + ((Double)$sub->price);
        //                 $step3 = true;


        //                 if( $step1 && $step2 && $step3){
        //                     $sub->save();
        //                     $wallet->save();
        //                     DB::commit();
        //                 }
        //             } catch (Exception $e) {
        //                 DB::rollback();
        //                 throw $e;
        //             }
        //         }
        //     }
        //     return $subscriptions;
        // } catch (\Exception $e) {
        // }
            // $currentDate = Carbon::now();
            // // $subscriptions = Subscription::whereDate('end_date', '<=', ($currentDate->toDateString()) . ' 00:00:00.000')->get();
            // $subscriptions = Subscription::whereRaw("STR_TO_DATE(end_date, '%Y-%m-%d') <= STR_TO_DATE(?, '%Y-%m-%d')", [$currentDate->toDateString()])->get();
            // foreach ($subscriptions as $subscription) {
            //     if ($subscription->auto_renewal == 1 && $subscription->state == 1) {
            //         $currentDate = Carbon::now();
                    

            //         // DB::beginTransaction();
            //         // try {
            //             //0 step identify some variables
            //             $step1 = false;
            //             $step3 = false;
            //             //1 step => udating the duration
                        
                        
            //             $subscription->start_date = ($currentDate->toDateString()) . ' 00:00:00.000';
            //             $dif=Carbon::parse($subscription->start_date)->diffInDays(Carbon::parse($subscription->end_date));
            //             $subscription->end_date = $currentDate->addDays($dif)->toDateString() . ' 00:00:00.000';
            //             $subscription->seen = 0;
            //             $subscription->state = 1;

            //             $step1 = true;



            //             //3 step => add the cost of renwal subscription to the remain amount
            //             $payment_remain = ((Double)$subscription->payment_remain) + ((Double)$subscription->price); //subtract from subscription remain
            //             $subscription->payment_remain = $payment_remain;
            //             $step3 = $subscription->save();
                        
                        
            //             if ($step1  && $step3) {

                            

            //                 $user = User::find($subscription->user_id);
            //                 if($user){
            //                     // $MessageController = new MassegesController();

            //                     $start = $subscription->start_date;
            //                     $end = $subscription->end_date;
            //                     $renew = ($subscription->auto_renewal == 0) ? "غير تلقائي" : "تلقائي";

            //                     try {
            //                         // $MessageController->sendSmsMessage("عزيزي المشترك '$user->user_name' في شبكة نيو برايت نت لقد تم التجديد الباقه الخاصه بك و تبدأ من تاريخ '$start' إلى تاريخ '$end' ونوع التجديد '$renew'. لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي", $user->phone_number);
            //                     } catch (Exception $exception) {
            //                     }
            //                 }
            //                 // DB::commit();
            //             }
            //         // } catch (Exception $e) {
            //         //     // DB::rollback();
            //         //     throw $e;
            //         // }
            //     } else {
            //         // DB::beginTransaction();
            //         try {
            //             $isExtended = Extension::where('subscription_id', $subscription->id)->exists();
            //             if ($isExtended) {
            //                 $extension = Extension::where('subscription_id', $subscription->id)->first();
            //                 $endDate = $extension->end_date;
            //                 $end_date = Carbon::parse($endDate);

            //                 if ($end_date->isAfter($currentDate)) {
            //                     $extension->delete();
            //                     $subscription->state = 0;
            //                     $subscription->seen = 0;
            //                 }
            //             } else {
            //                 $sub = Subscription::find($subscription->id);
            //                 $sub->state = 0;
            //                 $sub->seen = 0;
            //             }


            //             // DB::commit();
            //         } catch (Exception $e) {
            //             // DB::rollback();
            //             throw $e;
            //         }
            //     }
            // }
    }
        function test2(){
        //  try {
             $sub=[];
            
            $subscriptions = Subscription::all();
            foreach ($subscriptions as $subscription) {
                $remain =$subscription->payment_remain; 
                if($remain > 0){
                    $user = User::find($subscription->user_id);
                            $MessageController = new MassegesController();
                            try {
                                $MessageController->sendSmsMessage("عزيزي المشترك $user->name في شبكة نيو برايت نت إجمالي المبالغ المستحقة $subscription->payment_remain لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي", $user->phone_number);
                            } catch (Exception $exception) {
                            }
                    
                }
            }

            // $filteredSubscriptions = $subscriptions->filter(function ($subscription) {
            //     // Add your filtering logic here
            //     return (((Double)$subscription->payment_remain) > 0);
            // });
            
            // foreach ($subscriptions as $subscription) {
            //             if($subscription->payment_remain > 0){
            //                 try {
            //                 $sub[]=$subscription;
            //                 $user = User::find($subscription->user_id);
                        
            //                 $MessageController = new MassegesController();
            //                 try {
                                
            //                     // $MessageController->sendSmsMessage("عزيزي المشترك $user->name في شبكة نيو برايت نت إجمالي المبالغ المستحقة $subscription->payment_remain لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي", $user->phone_number);
            //                 } catch (Exception $exception) {
            //                 }
                            
            //         } catch (Exception $e) {
                        
            //         }
            //     }
            // }
            return $sub;
        // } catch (\Exception $e) {
            
        // }
        // return 0;
    }

    public function index()
    {
        $admins = Admin::get();
        return $this->returnData('admins', $admins, 'success');
    }
    public function getAll()
    {
        $admins = Admin::get();
        return $this->returnData('admins', $admins, 'success');
    }
    public function get(Request $request)
    {
        try {
            $admin = Admin::find($request->id);
            return $this->returnData('admin', $admin, 'success');
        } catch (Exception $e) {
            return $this->error(1, "this admin dosn't exist ! ");
        }
    }

    public function create(Request $request)
    {

        try {
            $rules = [
                "name" => "required",
                "email" => "required",
                "password" => "required",
                "phone_number" => "numeric",
            ];

            $validator = Validator::make($request->all(), $rules);

            if ($validator->fails()) {
                $code = $this->returnCodeAccordingToInput($validator);
                return $this->returnValidationError($code, $validator);
            } else {
                $admin = new Admin();
                $admin->name = $request->name;
                $admin->email = $request->email;
                $admin->password = bcrypt($request->password);
                $admin->phone_number = $request->phone_number;
                $success = $admin->save();
                if ($success) {
                    return $this->success(0, "the Admin profile has been created successfully!");
                } else {
                    return $this->error(1, "some thing went wrong while Creating this profile!");
                }
            }
        } catch (QueryException $e) {
            return $this->error(2, $e->getMessage());
        } catch (Exception $e) {
            return $this->error(1, "some thing went wrong while Creating this profile!");
        }
    }
    public function delete(Request $request)
    {
        try {
            $rules = [
                'id' => "required",
            ];
            $validator = Validator::make($request->all(), $rules);

            if ($validator->fails()) {
                $code = $this->returnCodeAccordingToInput($validator);
                return $this->returnValidationError($code, $validator);
            } else {
                $admin = Admin::find($request->id);
                $success = $admin->delete();
                if ($success) {
                    return $this->success(0, "the admin has been deleted successfully!");
                } else {
                    return $this->error(1, "some thing went wrong while deleting this admin!");
                }
            }
        } catch (QueryException $e) {
            return $this->error(2, $e->getMessage());
        } catch (Exception $e) {
            return $this->error(1, "some thing went wrong while deleting this admin!");
        }
    }
    public function edit(Request $request)
    {

        try {
            $rules = [
                "id" => "required",
                "name" => "required",
                "email" => "required",
                "password" => "required",
                "phone_number" => "numeric"
            ];

            $validator = Validator::make($request->all(), $rules);

            if ($validator->fails()) {
                $code = $this->returnCodeAccordingToInput($validator);
                return $this->returnValidationError($code, $validator);
            } else {

                $admin = Admin::find($request->id);
                $admin->name = $request->name;
                $admin->email = $request->email;
                $admin->phone_number = $request->phone_number;
                $admin->password = bcrypt($request->password);
                $success = $admin->save();

                if ($success) {
                    return $this->success(0, "the admin profile has been Updated!");
                } else {
                    return $this->error(1, "some thing went wrong while Updating this profile!");
                }
            }
        } catch (QueryException $e) {
            return $this->error(2, "there is already an email or phone with same value!");
        } catch (Exception $e) {
            return $this->error(1, "some thing went wrong while Updating this profile!");
        }
    }

    public function tableCounts()
    {

        $counts = [];
        $counts["admins"] = Admin::count();
        $counts["users"] = User::count();
        $counts["endPoints"] = EndPoint::count();
        $counts["subscriptions"] = Subscription::count();
        $counts["payments"] = Transaction::count();

        return $this->returnData('counts', $counts, 'success');
    }
    public function valid(Request $request)
    {
        $state = Valid::find(1);
        return $this->returnData('state', $state, 'success');
    }
    public function updateValid(Request $request)
    {
        $state = Valid::find(1);
        $state->state = $request->state;
        $state->save();
        return $this->returnData('state', $state, 'success');
    }
}
