<?php

namespace App\Http\Controllers;

use App\Models\SubscriptionLog;
use App\Traits\ApiResponseTrait;

use Illuminate\Http\Request;
use App\Models\Package;

class SubscriptionLogController extends Controller
{
    //
    use ApiResponseTrait;
    public function getAll()
    {
        $subscription = SubscriptionLog::get();
        foreach ($subscription as $sub){
            $sub['package']=Package::find($sub->package_id);
        }
        return $this->returnData('subscription', $subscription, 'success');
    }
}
