<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Tymon\JWTAuth\Contracts\JWTSubject;

class Admin extends Authenticatable  implements JWTSubject
{
    protected $table='admins';
    protected $fillable = [     
        'id',
        'name', 
        'email',
        'password',
        'phone_number',
        'created_at',
        'updated_at'	
    ];
    // protected $hidden = [
    //     'password'
    // ];
    public function getJWTIdentifier()
    {
        return $this->getKey();
    }

    public function getJWTCustomClaims()
    {
        return [];
    }
}
