<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Collection extends Model
{
    use HasFactory;
    protected $table='collections';
    protected $fillable = [ 
        'id', 
        'admin_id', 
        'endpoint_id', 
        'amount', 
        'collect_date', 
        'collect_time', 
        'note', 
        'created_at', 
        'updated_at'	    
    ];
    public function getJWTIdentifier()
    {
        return $this->getKey();
    }

    public function getJWTCustomClaims()
    {
        return [];
    }
}
