<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Tymon\JWTAuth\Contracts\JWTSubject;
class EndPoint extends Authenticatable  implements JWTSubject
{
    protected $table='endpoints';
    protected $fillable = [  
        'id',	
        'email',	
        'password',
        'phone_number',
        'address',	
        'place_name',
        'created_at',
        'updated_at'	   
    ];
    // protected $hidden = [
    //     'password'
    // ];
    public function getJWTIdentifier()
    {
        return $this->getKey();
    }

    public function getJWTCustomClaims()
    {
        return [];
    }
}


